// Lorentz attractor.js
// helmut jaksch	
// 
// for scripts/Splineobj Folder

// definitions for property block GUI
function buildUI(obj) {
    obj.setParameter("name","Lorenz attractor");
    
    obj.addParameterInt("section",50,10,3600,true,true);
    
    obj.addParameterSeparator("variables");
	// "variable", default, lower / upper limit, ???, ???
    obj.addParameterFloat("x",0,0,10,true,true);
    obj.addParameterFloat("y",1,0,10,true,true);
    obj.addParameterFloat("z",0,0,10,true,true);

    obj.addParameterFloat("time",3000,0,300000,true,true);
    obj.addParameterFloat("prandtl",10,0,100,true,true);
    obj.addParameterFloat("rayleigh",28,0,100,true,true);    
    obj.addParameterFloat("beta",8/3,0,100,true,true);    
}

function buildObject(obj) {
	// definitions local variables
    var x=obj.getParameter("x");
    var y=obj.getParameter("y");
    var z=obj.getParameter("z");
    var i
        
    // obj.core = holds ∑ data of slpne object
    var spline = obj.core();
    
    // assign user set parameters
    var time = obj.getParameter("time");
    var prandtl = obj.getParameter("prandtl");
    var rayleigh = obj.getParameter("rayleigh");
    var beta = obj.getParameter("beta");
    var dt = 0.001

    var pos=new Vec3D (x, y, z)
	spline.move(pos); // move pen to start
       
    // for loop (counter = start; max; increment)
    for (i = 0;i <= time ;i++) {
    	// dx/dt = σ(y – x)
		// dy/dt = x(ρ – z) – y
		// dz/dt = xy – βz
		
        var x = x + ((prandtl * (y - x))*dt)
        var y = y + ((x * (rayleigh - z)- y)*dt)
        var z = z + (((x * y) - (beta * z))*dt)
        // console debuggerq
        // print(dt)
     	// print(dx+", "+dy+", "+dz)
		// print(x+", "+y+", "+z)

		// new Vec3D(x, y, z) = returns point (x, y, z)
        var pos=new Vec3D (x, y, z)

	// generate plot	    
			spline.line(pos); // draw segment
    }
 
    // spline.close() = draw line to close path   
    // spline.close();
}